clear; clc; close all;

f = @(x,y) (1 - x).^2 + 100 * (y - x.^2).^2 ;
w0 = [1; 1.1];
numit = 1000;

figure(1); clf; hold on;
x = linspace(.8, 1.2, 100);
[X,Y] = meshgrid(x);
contour(X,Y, f(X,Y), 100, 'DisplayName', 'f(w)');

scatter(w0(1), w0(2), 'c*', 'DisplayName', 'w_0')
axis([min(x), max(x), min(x), max(x)])
xlabel('x')
ylabel('y')
legend()


%% (b): impelment gradient and hessian
% TODO: write your own function


%% (c): test with two different Hessian approximations
% TODO: fill in the correct parameters (replace "NaN")
%% i) gradient desc, rho = 100
W_gd100 = newton_type(NaN);
plot(W_gd100(1,:), W_gd100(2,:), 'rx-', 'DisplayName', 'GD, \rho=100' )


%% i) gradien desc, rho = 500
W_gd500 = newton_type(NaN);
plot( W_gd500(1,:), W_gd500(2,:), 'bo-', 'DisplayName', 'GD, \rho=500' )

%% i) gradien desc, rho = 550
W_gd500 = newton_type(NaN);
plot( W_gd500(1,:), W_gd500(2,:), 'ms-', 'DisplayName', 'GD, \rho=550' )


%% ii) exact hessian
W_eh = newton_type(NaN);
plot( W_eh(1,:), W_eh(2,:), 'k^-', 'DisplayName', 'exact Hessian' )


%% plot of convergence speed
figure(2); clf; hold on;
xopt = [1;1];                               % true minimizer
plot(0:numit, log10(max(abs(W_gd500 - xopt))))
plot(0:numit, log10(max(abs(W_eh - xopt))))
legend('GD, \rho=500', 'exact hessian')
xlabel('iteration k')
ylabel('log ||w_k - w^* ||_\infty')

%% (d): now use Casadi
import casadi.*
% TODO: calculate gradient, hessian via Casadi

% exact hessian
% TODO: fill in the correct parameters (replace "NaN")
W_cas = newton_type(NaN);

figure(1)
plot(W_cas(1,:), W_cas(2,:), 'gv-','DisplayName', 'exact Hessian, casadi');